/*
  Velleman_8056_16F84.h - Library for driving velleman 8056 8 relay board RS232 customized with a 16F84 pic for increased speed com.
  Created by Daniel CALLERAND, June 24, 2011.
  Released as is without any kind of guarantee except it works for me as i wanted to and i hope you find it useful. 
*/

#include "WProgram.h"

#ifndef Velleman_8056_16F84_h
#define Velleman_8056_16F84_h

class Velleman_8056_16F84
{
  public:
 
	Velleman_8056_16F84( int rs232Pin, int speed);
    void emergencyStop();

    void setRelay(unsigned char relay);
    void clearRelay(unsigned char relay);
    void toggleRelay(unsigned char relay);
    void sendByte(unsigned char statut_byte);
    void incRpt();
    void decRpt();
    void setRpt(int rpt);
    byte getCmd();
    void store(int mem);
    void recall(int mem);
	void run();
	void stopRunning();
	bool isRunning();
	void next();
	int	 runDelay;
  private:
    int  _rs232Pin;
    int  _rptCmd;
    long _bitPeriod;
	int	 _comSpeed;
	bool _run;
	int _runCount;

    byte _cmd;
	
	byte _mems[8];
    
//    void checkSum();

    void print(uint8_t);

	void sendCommand();
};

#endif
