/*
  Velleman_8056_16F84.h - Library for driving velleman 8056 8 relay board RS232 customized with a 16F84 pic for increased speed com.
  Created by Daniel CALLERAND, June 24, 2011.
  Released as is without any kind of guarantee except it works for me as i wanted to and i hope you find it useful. 
*/

#include "WProgram.h"

#ifndef Velleman_8056_h
#define Velleman_8056_h

class Velleman_8056
{
  public:
    Velleman_8056(int rs232Pin, unsigned char address);
    Velleman_8056(int rs232Pin, unsigned char address, int rpt);

    void emergencyStop();
    void displayAddress();
    void setAddress(unsigned char address);
    void forceAllCardAddr();

    void setRelay(unsigned char relay);
    void clearRelay(unsigned char relay);
    void toggleRelay(unsigned char relay);
    void sendByte(unsigned char statut_byte);
    void incRpt();
    void decRpt();
    void setRpt(int rpt);
    
  private:
    int  _rs232Pin;
    int  _rptCmd;
    long _bitPeriod;
	int	 _comSpeed;


    unsigned char _address;
    unsigned char _cmd[5];
    
    void checkSum();


    void printNumber(unsigned long, uint8_t);
    void print(char);
    void print(const char[]);
    void print(uint8_t);
    void print(int);
    void print(unsigned int);
    void print(long);
    void print(unsigned long);
    void print(long, int);
    void println(void);
    void println(char);
    void println(const char[]);
    void println(uint8_t);
    void println(int);
    void println(long);
    void println(unsigned long);
    void println(long, int);
    void sendCommand();
};

#endif
