#include <PS2Keyboard.h>

#include <Velleman_8056.h>

Velleman_8056 myRelay(5,0x01);

const int DataPin = 4;
const int IRQpin =  3;

PS2Keyboard keyboard;
    

void setup() {
   myRelay.emergencyStop();
   myRelay.emergencyStop();
   myRelay.emergencyStop();
   delay(1000);
   
   keyboard.begin(DataPin, IRQpin);
   
   Serial.begin(9600);
   Serial.println("Debug :");

  if (keyboard.available()) {
     keyboard.read();
  }
    
}

void loop() {
  if (keyboard.available()) {

    // read the next key
    char c = keyboard.read();
    switch( c ) {
      case '1' :
         myRelay.toggleRelay('1');
      break;
      case '2' :
         myRelay.toggleRelay('2');
      break;
      case '3' :
         myRelay.toggleRelay('3');
      break;
      case '4' :
         myRelay.toggleRelay('4');
      break;
      case '5' :
         myRelay.toggleRelay('5');
      break;
      case '6' :
         myRelay.toggleRelay('6');
      break;
      case '7' :
         myRelay.toggleRelay('7');
      break;
      case '8' :
         myRelay.toggleRelay('8');
      break;
      case 'a' :
         myRelay.setRelay('1');
      break;
      case 'z' :
         myRelay.setRelay('2');
      break;
      case 'e' :
         myRelay.setRelay('3');
      break;
      case 'r' :
         myRelay.setRelay('4');
      break;
      case 't' :
         myRelay.setRelay('5');
      break;
      case 'y' :
         myRelay.setRelay('6');
      break;
      case 'u' :
         myRelay.setRelay('7');
      break;
      case 'i' :
         myRelay.setRelay('8');
      break;
      case 'o' :
         myRelay.setRelay('9');
      break;

      case 'q' :
         myRelay.clearRelay('1');
      break;
      case 's' :
         myRelay.clearRelay('2');
      break;
      case 'd' :
         myRelay.clearRelay('3');
      break;
      case 'f' :
         myRelay.clearRelay('4');
      break;
      case 'g' :
         myRelay.clearRelay('5');
      break;
      case 'h' :
         myRelay.clearRelay('6');
      break;
      case 'j' :
         myRelay.clearRelay('7');
      break;
      case 'k' :
         myRelay.clearRelay('8');
      break;
      case 'l' :
         myRelay.clearRelay('9');
      break;
      case ' ' :
         myRelay.emergencyStop();
      break;
      case '+' :
         myRelay.incRpt();
      break;
      
      case '-' :
         myRelay.decRpt();
      break;
      case '*' :
         myRelay.setRpt(2);
      break;
      

    }
    Serial.print(c,HEX);
    Serial.print(" ");
    Serial.println(c);


  }

  
}


